#pragma once
#include "dx_dev.h"
#include <string>
#include <vector>

struct MESHMATERIALINFO{
	D3DMATERIAL9 material;
	std::string strTextureName;
};

struct MESHVERTEX{	//蔻p̃XPgbV
	D3DVECTOR vPos;
	D3DCOLOR diffuse;
	D3DCOLOR specular;
	float tu,tv;
};
enum{MESHVERTEX_FVF=(D3DFVF_XYZ | D3DFVF_DIFFUSE | D3DFVF_SPECULAR | D3DFVF_TEX1)};

class CDXMesh{
protected:
	//{
	std::vector<MESHMATERIALINFO> m_MaterialArray;
	LPD3DXMESH m_lpMesh;

	bool ConvertMesh(LPD3DXBASEMESH lpOrgMesh,LPD3DXMESH &lpMesh);
public:
	CDXMesh();
	virtual ~CDXMesh();
	bool Load(CDXDevice&,LPCTSTR);

	//ʏ̎擾
	bool GetMeshInfo(std::vector<MESHVERTEX> &rVertexArray,std::vector<DWORD> &rIndexArray,std::vector<D3DXATTRIBUTERANGE> &rAttributes);
	void GetMaterialArray(std::vector<MESHMATERIALINFO> &rMaterialArray){rMaterialArray=m_MaterialArray;}

	void Destroy();
};


